var globalThis = this;
function __skpm_run (key, context) {
  globalThis.context = context;

var exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/my-command.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/my-command.js":
/*!***************************!*\
  !*** ./src/my-command.js ***!
  \***************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var sketch__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! sketch */ "sketch");
/* harmony import */ var sketch__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(sketch__WEBPACK_IMPORTED_MODULE_0__);
 // documentation: https://developer.sketchapp.com/reference/api/

var utils = __webpack_require__(/*! ./utils */ "./src/utils.js");

/* harmony default export */ __webpack_exports__["default"] = (function () {
  var doc = context.document;

  if (utils.checkDocumentIsDraft(doc)) {
    console.log("Document is draft ☝️");
    utils.showDocumentIsDraftDialog();
    return;
  }

  if (utils.checkIfDocumentEdited(doc)) {
    console.log("Document is edited ☝️");
    var alert = NSAlert.alloc().init();
    alert.setMessageText('Document is not saved');
    alert.setInformativeText('Document is not saved.');
    alert.addButtonWithTitle('Save and Continue');
    alert.addButtonWithTitle('Cancel');
    alert.setInformativeText('To capture the latest changes in this Sketch document, Monday Hero needs to save it first.');
    var alertResponse = alert.runModal();

    if (alertResponse == NSAlertFirstButtonReturn) {
      //Ok response.
      doc.showMessage('Saving document…');
      doc.saveDocument(null);

      while (doc.isDocumentEdited()) {
        NSRunLoop.currentRunLoop().runMode_beforeDate(NSDefaultRunLoopMode, NSDate.distantFuture());
      }

      console.log('Saving is completed.');
    } else if (alertResponse == NSAlertSecondButtonReturn) {
      return;
    }

    alertResponse = null;
    alert = null;
  }

  console.log("Document Url:" + doc.fileURL());
  var sketchFilePath = doc.fileURL().path();
  var document = sketch__WEBPACK_IMPORTED_MODULE_0___default.a.getSelectedDocument();
  var selection = document.selectedLayers;
  var artboardIds = [];
  var artboardNames = [];
  var artboardCount = 0;
  selection.forEach(function (layer) {
    var artboardLayer = utils.findParentArtboard(layer);

    if (artboardLayer) {
      artboardCount += 1;
      utils.addUnique(artboardLayer.id, artboardIds);
      utils.addUnique(artboardLayer.name, artboardNames); // artboardIds.push(artboardLayer.id);
      // artboardNames.push(artboardLayer.name);
    }
  });

  if (artboardCount === 0) {
    utils.showNoArtboardSelectedDialog();
    console.log("No Artboards are selected ☝️");
    return;
  }

  console.log(artboardIds);
  console.log(artboardNames);
  var templateFilePath = utils.getTemplateFilePath();
  console.log('Temp File Name:' + templateFilePath);
  var appInfo = utils.sketchAppInfo();
  var info = NSMutableDictionary.dictionary();
  info.setObject_forKey(sketchFilePath, "sketchFilePath");
  info.setObject_forKey(artboardIds, "artboardIds");
  info.setObject_forKey(artboardNames, "artboardNames");

  if (appInfo.version) {
    info.setObject_forKey(appInfo.version, "version");
  }

  if (appInfo.sketchtoolPath) {
    info.setObject_forKey(appInfo.sketchtoolPath, "sketchtoolPath");
  }

  if (appInfo.sketchmigratePath) {
    info.setObject_forKey(appInfo.sketchmigratePath, "sketchmigratePath");
  }

  info.writeToFile_atomically(templateFilePath, false);
  console.log(info);
  utils.launchMondayHero(doc, templateFilePath); // [directives setObject:artboardIds forKey:@"artboardIds"];
  // [directives setObject:pageIds forKey:@"pageIds"];
  // [directives setObject:format forKey:@"format"];
  // [directives setObject:uniqueArtboardSizes forKey:@"artboardSizes"];
  // [directives setObject:assetLibraries forKey:@"assetLibraries"];
  // [directives setObject:containsArtboard forKey:@"containsArtboard"];
});

/***/ }),

/***/ "./src/utils.js":
/*!**********************!*\
  !*** ./src/utils.js ***!
  \**********************/
/*! exports provided: checkDocumentIsDraft, checkIfDocumentEdited, showDocumentIsDraftDialog, showNoArtboardSelectedDialog, showDocumentIsEditedDialog, typeCheck, findParentArtboard, addUnique, sketchAppInfo, getTemplateFilePath, launchMondayHero */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "checkDocumentIsDraft", function() { return checkDocumentIsDraft; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "checkIfDocumentEdited", function() { return checkIfDocumentEdited; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "showDocumentIsDraftDialog", function() { return showDocumentIsDraftDialog; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "showNoArtboardSelectedDialog", function() { return showNoArtboardSelectedDialog; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "showDocumentIsEditedDialog", function() { return showDocumentIsEditedDialog; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "typeCheck", function() { return typeCheck; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "findParentArtboard", function() { return findParentArtboard; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addUnique", function() { return addUnique; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sketchAppInfo", function() { return sketchAppInfo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getTemplateFilePath", function() { return getTemplateFilePath; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "launchMondayHero", function() { return launchMondayHero; });
/* harmony import */ var sketch__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! sketch */ "sketch");
/* harmony import */ var sketch__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(sketch__WEBPACK_IMPORTED_MODULE_0__);
 // documentation: https://developer.sketchapp.com/reference/api/

function checkDocumentIsDraft(doc) {
  return !doc.fileURL() || doc.isDraft();
}
function checkIfDocumentEdited(doc) {
  return doc.isDocumentEdited();
}
function showDocumentIsDraftDialog() {
  var alert = NSAlert.alloc().init();
  alert.setMessageText('Document is not saved');
  alert.setInformativeText('Please save the document before exporting to Monday Hero.');
  alert.addButtonWithTitle('OK');
  alert.addButtonWithTitle('Cancel');
  alert.runModal();
}
function showNoArtboardSelectedDialog() {
  var alert = NSAlert.alloc().init();
  alert.setMessageText('No artboard is selected');
  alert.setInformativeText('Please select the artboards you want to export to Monday Hero.\n\nSelecting a layer inside the artboard should be enough.');
  alert.addButtonWithTitle('OK');
  alert.runModal();
}
function showDocumentIsEditedDialog(doc) {
  var alert = NSAlert.alloc().init();
  alert.setMessageText('Document is not saved');
  alert.setInformativeText('Document is not saved.');
  alert.addButtonWithTitle('Save and Continue');
  alert.addButtonWithTitle('Cancel');
  alert.setInformativeText('To capture the latest changes in this Sketch document, Monday Hero needs to save it first.\n\n☝️');
  var alertResponse = alert.runModal();

  if (alertResponse == NSAlertFirstButtonReturn) {
    //Ok response.
    doc.showMessage('Saving document…');
    doc.saveDocument(null);

    while (doc.isDocumentEdited()) {
      NSRunLoop.currentRunLoop().runMode_beforeDate(NSDefaultRunLoopMode, NSDate.distantFuture());
    }

    console.log('Saving is completed.');
  } else if (alertResponse == NSAlertSecondButtonReturn) {
    return;
  }

  alertResponse = null;
  alert = null;
}
function typeCheck(layer, type) {
  return layer.type == type;
}
function findParentArtboard(layer) {
  if (typeCheck(layer, 'Artboard')) {
    console.log(layer.id + ': layer type' + layer.type);
    return layer;
  } else if (layer.parent) {
    console.log(layer.parent.id + ': layer parent type' + layer.parent.type);
    return findParentArtboard(layer.parent);
  } else {
    return undefined;
  }
}
function addUnique(item, toArray) {
  if (toArray.indexOf(item) === -1) {
    console.log('item added.');
    toArray.push(item);
  }
}
function sketchAppInfo() {
  var version = NSBundle.mainBundle().objectForInfoDictionaryKey('CFBundleShortVersionString');
  var sketchtoolPath = NSBundle.mainBundle().pathForResource_ofType_inDirectory("sketchtool", null, "sketchtool/bin");
  var sketchmigratePath = NSBundle.mainBundle().pathForResource_ofType_inDirectory("sketchmigrate", null, "sketchtool/bin");
  console.log('version:' + version);
  console.log('sketchtoolPath:' + sketchtoolPath);
  console.log('sketchmigratePath:' + sketchmigratePath);
  return {
    version: version,
    sketchtoolPath: sketchtoolPath,
    sketchmigratePath: sketchmigratePath
  };
}
function getTemplateFilePath() {
  var name = NSUUID.UUID().UUIDString().stringByAppendingPathExtension("mhero");
  var temporaryDirectory = NSTemporaryDirectory();
  var path = temporaryDirectory.stringByAppendingPathComponent(name);
  return path;
}
function launchMondayHero(doc, path) {
  var workspace = NSWorkspace.sharedWorkspace();
  var applicationPath = workspace.absolutePathForAppBundleWithIdentifier("io.mondayhero.osxuploader");

  if (!applicationPath) {
    NSApp.displayDialog_withTitle("Please make sure that you installed Monday Hero Uploader and launched it: https://mondayhero.io/download", "Could not find Monday Hero Uploader");
    return;
  }

  doc.showMessage('Saving Launching Monday Hero Uploader!');
  workspace.openFile_withApplication_andDeactivate(path, applicationPath, true);
}

/***/ }),

/***/ "sketch":
/*!*************************!*\
  !*** external "sketch" ***!
  \*************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("sketch");

/***/ })

/******/ });
  if (key === 'default' && typeof exports === 'function') {
    exports(context);
  } else {
    exports[key](context);
  }
}
globalThis['onRun'] = __skpm_run.bind(this, 'default')

//# sourceMappingURL=my-command.js.map